#include<iostream>
#include<cmath>
#include <cstdlib>
using namespace std;
main()
{
	int t, n, m, p, i, j;
	long long int x;
	cin >> t;
	int h[t];
	for(p = 0; p < t; p++)
	{
		h[p] = 1;
		cin >> n >> m;
		long long int a[n], b[m];
		for(i = 0; i < n; i++)
		{
			cin >> a[i];
		}
		for(j = 0; j < m; j++)
		{
			cin >> b[j];
		}
		x = abs(a[0] - a[1]);
		if(n > 2)
		{
			for(i = 1; i < n; i++)
			{
				if(llabs(a[i] - a[i - 1]) % x != 0)
				{
					x = x / 2;
				}
			}
			for(i = 0; i < n; i++)
			{
				for(j = 0; j < m; j++)
				{
					if(llabs(a[i] - b[j]) == x)
					{
						h[p] = 0;
						break;
					}
				}
			}
		}
		else
		{
				for(j = 0; j < m; j++)
				{
					if(x == b[j])
					{
						h[p] = 0;
						break;
					}
				}
		}
	}
	for(p = 0; p < t; p++)
	{
		cout << h[p] << endl;
	}
	return 0;
}